config/routes.rb
Rails.application.routes.draw do
  devise_for :users
  root 'posts#index'

  resources :users, only: [:show] do
    member do
      post :follow
      post :unfollow
    end

    resources :posts, except: [:index] do
      resources :likes do
        member do
          post :up
          post :down
        end
      end

      collection do
        get :subscriptions
      end

      resources :comments, only: [:create,:destroy]
    end

  end

  resources :posts, only: [] do
    resources :likes, only: [] do
      collection do
        post :up
        delete :down
      end
    end
  end

end

app/models/comment.rb
class Comment < ApplicationRecord
  belongs_to :post
  belongs_to :user

  validates :text, presence: true, length: { in: 3..150 }
end

app/controllers/comments_controller.rb
class CommentsController < ApplicationController
  before_action :authenticate_user!, only: [:create, :destroy]
  before_action :set_comment, :set_comment, only: [:destroy]
  before_action :check_current_user, only: [:destroy]
  before_action :set_user, :set_post, only: [:create]
  # before_action :set_post, only: [:create]

  def create
    @comment = Comment.new(comment_params)
    @comment.post = @post
    @comment.user = current_user

    if @comment.save
      flash[:success] = "You create comment!"
      redirect_to user_post_path(@user, @post)
    else
      flash[:danger] = "#{@comment.errors.full_messages.join(", ")}"
      redirect_to user_post_path(@user, @post)
    end
  end

  def destroy
    @comment.destroy
    flash[:success] = "You delete comment!"
    redirect_back(fallback_location: root_path)
  end


  private
  def set_user
    @user = User.find(params[:user_id])
  end

  def set_post
    @post = Post.find(params[:post_id])
  end

  def set_comment
    @comment = Comment.find(params[:id])
  end

  def check_current_user
    unless current_user == @comment.user
      flash[:danger] = "You are incorrect user!"
      redirect_back(fallback_location: root_path )
    end
  end

  def comment_params
    params.require(:comment).permit(:text)
  end
end

app/helpers/comments_helper.rb
module CommentsHelper
end

app/views/comments/_comment.html.erb
<div class="col-12 col-sm-10 col-md-8 m-auto">
  <div class="comment mt-3">
    <div class="card border-primary mb-3 bg-light">
      <div class="card-header"><%= link_to comment.user.login, user_path(comment.user) %></div>
      <div class="card-body">
        <p class="card-text"><%= comment.text %></p>
        <%= link_to 'Удалить', user_post_comment_path(@user, @post, comment), :class => 'btn btn-danger', method: :delete if current_user == comment.user %>
      </div>
    </div>
  </div>
</div>

app/views/comments/_form.html.erb
<div class="col-12 col-sm-10 col-md-8 m-auto">
  <%= form_with model: [current_user, @post, comment], local: true do |f| %>
  <% if comment.errors.any? %>
  <div id="errors">
    <ul>
      <% post.errors.full_messages.each do |message| %>
      <li><%= message %></li>
      <% end %>
    </ul>
  </div>
  <% end %>
  <%= f.text_area :text, :class => 'form-control', rows: '5' %>
  <%= f.submit :class => 'btn btn-primary my-2' %>
  <% end %>
</div>